petsc-3.10.5 2019-03-28
Report Typos and Errors

# PetscSFFetchAndOpEnd

end operation started in matching call to PetscSFFetchAndOpBegin() to fetch values from roots and update atomically by applying operation using my leaf value

### Synopsis

    #include "petscsf.h"
    PetscErrorCode PetscSFFetchAndOpEnd(PetscSF sf,MPI_Datatype unit,void *rootdata,const void *leafdata,void *leafupdate,MPI_Op op)

Collective

### Input Arguments

| sf | - star forest
| unit | - data type
| leafdata | - leaf values to use in reduction
| op | - operation to use for reduction

### Output Arguments

| rootdata | - root values to be updated, input state is seen by first process to perform an update
| leafupdate | - state at each leaf's respective root immediately prior to my atomic update

### See Also

PetscSFComputeDegreeEnd(), PetscSFReduceEnd(), PetscSFSetGraph()

### Level

advanced

### Location

src/vec/is/sf/interface/sf.c

### Examples

src/vec/is/sf/examples/tutorials/ex1.c.html

### Implementations

PetscSFFetchAndOpEnd_Basic in src/vec/is/sf/impls/basic/sfbasic.c
PetscSFFetchAndOpEnd_Window in src/vec/is/sf/impls/window/sfwindow.c
Index of all PetscSF routines
Table of Contents for all manual pages
Index of all manual pages